## rustc 1.39.0+dfsg1

=== debian/changelog ===
rustc (1.39.0+dfsg1-4+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.

 -- Peter Micheal Green <plugwash@raspbian.org>  Sat, 28 Dec 2019 09:52:57 +0000

rustc (1.39.0+dfsg1-4) unstable; urgency=medium

  * Update to LLVM 9. (Closes: #946886)

 -- Ximin Luo <infinity0@debian.org>  Mon, 23 Dec 2019 03:21:02 +0000

rustc (1.39.0+dfsg1-3) unstable; urgency=medium

  * Fix mips patch involving mxgot for new RUSTFLAGS behaviour.

 -- Ximin Luo <infinity0@debian.org>  Fri, 06 Dec 2019 22:18:53 +0000

rustc (1.39.0+dfsg1-2) unstable; urgency=medium

  * Include reproducibility patch for compiler-builtins.
  * Use python3 instead of python to run rustbuild. (Closes: #938422)
  * Expand d-ignore-error-detail-diff.patch for unfixed upstream #53081.

 -- Ximin Luo <infinity0@debian.org>  Thu, 05 Dec 2019 22:51:41 +0000

rustc (1.39.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 30 Nov 2019 22:20:48 +0000

rustc (1.38.0+dfsg1-2) unstable; urgency=medium

  * Fix building with rustc 1.38.0
  * Fix building with cargo 0.40.0

 -- Ximin Luo <infinity0@debian.org>  Fri, 29 Nov 2019 00:05:16 +0000

rustc (1.38.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 26 Nov 2019 14:41:46 +0000

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               python3:native,
               cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
               rustc:native (>= 1.38.0+dfsg) <!pkg.rustc.dlstage0>,
               rustc:native (<= 1.39.0++)    <!pkg.rustc.dlstage0>,
               llvm-9-dev:native,
               llvm-9-tools:native,
               libllvm9 (>= 1:9.0.1-2),
               autotools-dev,
               cmake (>= 3.0) | cmake3,
# needed by some vendor crates
               pkg-config,
# this is sometimes needed by rustc_llvm
               zlib1g-dev:native,
               zlib1g-dev,
# used by rust-installer
               liblzma-dev:native,
# test dependencies:
               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# below are optional tools even for 'make check'
               gdb (>= 7.12) <!nocheck>,
# Work around #864741. The version constraint for gdb above should already do
# that, but this will keep things covered even in the case that they change
# gdb-minimal to do a versioned Provides: gdb.
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
               curl <pkg.rustc.dlstage0>,
               ca-certificates <pkg.rustc.dlstage0>,
Build-Conflicts: gdb-minimal <!nocheck>
# ^ That version of rustc is broken
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends: cargo (>= 0.40.0~~), cargo (<< 0.41.0~~), rust-gdb | rust-lldb
Suggests: rust-doc, rust-src, lld-9
Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.39
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.39 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: libstd-rust-dev-wasm32-cross
Section: libdevel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, lld-9
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries, for cross-compiling to the wasm32-unknown-unknown target.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-9, ${misc:Depends}, python3-lldb-9
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Recommends: cargo-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
RUSTFLAGS += --cap-lints warn --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo
ifneq (,$(filter $(DEB_BUILD_ARCH), sparc64))
export CARGO_INCREMENTAL = 0
endif

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 9
OLD_LLVM_VERSION = 8
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py
RUSTBUILD_FLAGS = --config debian/config.toml -vvv --on-fail env
# TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
# an insane blow up in the time it takes to run tests. See upstream #37477 for
# details. Upstream worked around it in #38984 but in Debian we can't take
# advantage of that work-around, because we want as much debuginfo as possible
# (so we set debuginfo-lines = true, debuginfo-only-std = false) so we have to
# work around it instead by disabling backtrace when running tests.
RUSTBUILD_TEST = python3 src/bootstrap/bootstrap.py test
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif
# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; echo $$channel; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
#ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
#endif

debian/rust-src.%: debian/rust-src.%.in
	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
		"$<" > "$@"

debian/dh_auto_configure.stamp: debian/config.toml
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude='*.patch' --exclude-dir='.debhelper' -R debian
	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
	test ! -e vendor/openssl
	# fail the build if we didn't update d-ignore-error-detail-diff.patch
	! grep -Ri '\$SRC_DIR' src/test/
	# fail the build if our version contains ~exp and we are not releasing to experimental

## rustc 1.40.0+dfsg1

=== src/test/run-make-fulldeps/pgo-gen-no-imp-symbols/Makefile ===
# needs-profiler-support

-include ../tools.mk

COMPILE_FLAGS=-O -Ccodegen-units=1 -Cprofile-generate="$(TMPDIR)"

# LLVM doesn't yet support instrumenting binaries that use unwinding on MSVC:
# https://github.com/rust-lang/rust/issues/61002
#
# Things work fine with -Cpanic=abort though.
ifdef IS_MSVC
COMPILE_FLAGS+= -Cpanic=abort
endif

all:
	$(RUSTC) $(COMPILE_FLAGS) --emit=llvm-ir test.rs
	# We expect symbols starting with "__llvm_profile_".
	$(CGREP) "__llvm_profile_" < $(TMPDIR)/test.ll
	# We do NOT expect the "__imp_" version of these symbols.
	$(CGREP) -v "__imp___llvm_profile_" < $(TMPDIR)/test.ll # 64 bit
	$(CGREP) -v "__imp____llvm_profile_" < $(TMPDIR)/test.ll # 32 bit

=== src/test/run-make-fulldeps/redundant-libs/Makefile ===
-include ../tools.mk

ifdef IS_WINDOWS
all:
else

# rustc will remove one of the two redundant references to foo below.  Depending
# on which one gets removed, we'll get a linker error on SOME platforms (like
# Linux).  On these platforms, when a library is referenced, the linker will
# only pull in the symbols needed _at that point in time_.  If a later library
# depends on additional symbols from the library, they will not have been pulled
# in, and you'll get undefined symbols errors.
#
# So in this example, we need to ensure that rustc keeps the _later_ reference
# to foo, and not the former one.
RUSTC_FLAGS = \
    -l static=bar \
    -l foo \
    -l static=baz \
    -l foo \
    -Z print-link-args

all: $(call DYLIB,foo) $(call STATICLIB,bar) $(call STATICLIB,baz)
	$(RUSTC) $(RUSTC_FLAGS) main.rs
	$(call RUN,main)

endif

=== src/test/run-make-fulldeps/reproducible-build-2/Makefile ===
-include ../tools.mk

# ignore-musl
# ignore-windows
# Objects are reproducible but their path is not.

all:  \
	fat_lto \
	sysroot

fat_lto:
	rm -rf $(TMPDIR) && mkdir $(TMPDIR)
	$(RUSTC) reproducible-build-aux.rs
	$(RUSTC) reproducible-build.rs -C lto=fat
	cp $(TMPDIR)/reproducible-build $(TMPDIR)/reproducible-build-a
	$(RUSTC) reproducible-build.rs -C lto=fat
	cmp "$(TMPDIR)/reproducible-build-a" "$(TMPDIR)/reproducible-build" || exit 1

sysroot:
	rm -rf $(TMPDIR) && mkdir $(TMPDIR)
	$(RUSTC) reproducible-build-aux.rs
	$(RUSTC) reproducible-build.rs --crate-type rlib --sysroot $(shell $(RUSTC) --print sysroot) --remap-path-prefix=$(shell $(RUSTC) --print sysroot)=/sysroot
	cp -r $(shell $(RUSTC) --print sysroot) $(TMPDIR)/sysroot
	cp $(TMPDIR)/libreproducible_build.rlib $(TMPDIR)/libfoo.rlib
	$(RUSTC) reproducible-build.rs --crate-type rlib --sysroot $(TMPDIR)/sysroot --remap-path-prefix=$(TMPDIR)/sysroot=/sysroot
	cmp "$(TMPDIR)/libreproducible_build.rlib" "$(TMPDIR)/libfoo.rlib" || exit 1

=== src/test/run-make/wasm-custom-sections-opt/Makefile ===
-include ../../run-make-fulldeps/tools.mk

# only-wasm32-bare

all:
	$(RUSTC) foo.rs -O --target wasm32-unknown-unknown
	$(NODE) foo.js $(TMPDIR)/foo.wasm

=== debian/changelog ===
rustc (1.40.0+dfsg1-5+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.

 -- Raspbian forward porter <root@raspbian.org>  Sat, 11 Jan 2020 11:16:08 +0000

rustc (1.40.0+dfsg1-5) unstable; urgency=medium

  * More python 2 -> 3 fixes.
  * Allow 24 failing tests on riscv64.
  * Reenable debuginfo for rustc, not just libstd.
  * Reenable backtraces during tests.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Jan 2020 13:35:46 +0000

rustc (1.40.0+dfsg1-4) unstable; urgency=medium

  * Experimental riscv64 support.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Jan 2020 05:40:11 +0000

rustc (1.40.0+dfsg1-3) unstable; urgency=medium

  * Work around upstream #59264 again. :/

 -- Ximin Luo <infinity0@debian.org>  Fri, 03 Jan 2020 22:05:16 +0000

rustc (1.40.0+dfsg1-2) unstable; urgency=medium

  * Fix more internal build scripts so they use python3.
  * Don't add -L/usr/lib/llvm when cross-compiling. (Closes: #941783)

 -- Ximin Luo <infinity0@debian.org>  Fri, 03 Jan 2020 20:18:46 +0000

rustc (1.40.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Ignore new test failing on arm that also fails in previous versions.

 -- Ximin Luo <infinity0@debian.org>  Sun, 29 Dec 2019 22:17:04 +0000

rustc (1.40.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Dec 2019 00:09:24 +0000

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,8 @@
                dpkg-dev (>= 1.17.14),
                python3:native,
                cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.38.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.39.0++)    <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.39.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.40.0++)    <!pkg.rustc.dlstage0>,
                llvm-9-dev:native,
                llvm-9-tools:native,
                libllvm9 (>= 1:9.0.1-2),
@@ -49,7 +49,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.40.0~~), cargo (<< 0.41.0~~), rust-gdb | rust-lldb
+Recommends: cargo (>= 0.41.0~~), cargo (<< 0.42.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src, lld-9
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
@@ -66,7 +66,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.39
+Package: libstd-rust-1.40
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -91,7 +91,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.39 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.40 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly

=== debian/rules ===
--- 
+++ 
@@ -44,13 +44,7 @@
 
 RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py
 RUSTBUILD_FLAGS = --config debian/config.toml -vvv --on-fail env
-# TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
-# an insane blow up in the time it takes to run tests. See upstream #37477 for
-# details. Upstream worked around it in #38984 but in Debian we can't take
-# advantage of that work-around, because we want as much debuginfo as possible
-# (so we set debuginfo-lines = true, debuginfo-only-std = false) so we have to
-# work around it instead by disabling backtrace when running tests.
-RUSTBUILD_TEST = python3 src/bootstrap/bootstrap.py test
+RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast
 # To run a specific test, run something like:
 #   $ debian/rules override_dh_auto_test-arch \
 #     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
@@ -163,9 +157,9 @@
 	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
 	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 # Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
-#ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
+ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
 	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
-#endif
+endif
 
 debian/rust-src.%: debian/rust-src.%.in
 	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
@@ -177,5 +171,12 @@
 	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
 	test ! -e vendor/openssl
 	# fail the build if we didn't update d-ignore-error-detail-diff.patch
-	! grep -Ri '\$SRC_DIR' src/test/
+	! grep -Ri '\$$SRC_DIR' src/test/
 	# fail the build if our version contains ~exp and we are not releasing to experimental
+	v="$(DEB_VERSION)"; test "$$v" = "$${v%~exp*}" -o "$(DEB_DISTRIBUTION)" = "experimental" -o "$(DEB_DISTRIBUTION)" = "UNRELEASED"
+	$(PRECONFIGURE_CHECK)
+	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
+	# work around #842634
+	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
+	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
+	# work around https://github.com/rust-lang/rust/issues/59264

=== debian/watch ===
version=4
# if you need to download other versions replace the URL below with this one:
# https://static.rust-lang.org/dist/index.html
# it's a bit slower to download, that's why we use the other one normally

opts="\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/(\d)[_.+-]?((beta|alpha)\.?\d*)$/$1~$2/,\
dversionmangle=s/\+dfsg\d*$//,\
downloadurlmangle=s/\.[gx]z/.xz/,\
filenamemangle=s/.*\/(.*)\.[gx]z(\..*)?/$1.xz$2/,\
repack,\
repacksuffix=+dfsg1,\
compression=xz,\
" \
 https://forge.rust-lang.org/infra/other-installation-methods.html \
 (?:.*/)rustc?-(\d[\d.]*(?:-[\w.]+)?)-src\.tar\.[gx]z

## rustc 1.41.0%2Bdfsg1%2Bllvm

=== src/test/run-make-fulldeps/pgo-indirect-call-promotion/Makefile ===
# needs-profiler-support

-include ../tools.mk

# This test makes sure that indirect call promotion is performed. The test
# programs calls the same function a thousand times through a function pointer.
# Only PGO data provides the information that it actually always is the same
# function. We verify that the indirect call promotion pass inserts a check
# whether it can make a direct call instead of the indirect call.

# LLVM doesn't support instrumenting binaries that use SEH:
# https://github.com/rust-lang/rust/issues/61002
#
# Things work fine with -Cpanic=abort though.
ifdef IS_MSVC
COMMON_FLAGS=-Cpanic=abort
endif

all:
	# We don't compile `opaque` with either optimizations or instrumentation.
	# We don't compile `opaque` with either optimizations or instrumentation.
	$(RUSTC) $(COMMON_FLAGS) opaque.rs
	# Compile the test program with instrumentation
	mkdir -p "$(TMPDIR)"/prof_data_dir
	$(RUSTC) $(COMMON_FLAGS) interesting.rs \
		-Cprofile-generate="$(TMPDIR)"/prof_data_dir -O -Ccodegen-units=1
	$(RUSTC) $(COMMON_FLAGS) main.rs -Cprofile-generate="$(TMPDIR)"/prof_data_dir -O
	# The argument below generates to the expected branch weights
	$(call RUN,main) || exit 1
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/prof_data_dir/merged.profdata \
		"$(TMPDIR)"/prof_data_dir
	$(RUSTC) $(COMMON_FLAGS) interesting.rs \
		-Cprofile-use="$(TMPDIR)"/prof_data_dir/merged.profdata -O \
		-Ccodegen-units=1 --emit=llvm-ir
	cat "$(TMPDIR)"/interesting.ll | "$(LLVM_FILECHECK)" filecheck-patterns.txt

=== src/llvm-project/clang-tools-extra/clangd/indexer/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

set(LLVM_LINK_COMPONENTS
    Support
    )

add_clang_executable(clangd-indexer
  IndexerMain.cpp
  )

target_link_libraries(clangd-indexer
  PRIVATE
  clangAST
  clangBasic
  clangDaemon
  clangFrontend
  clangIndex
  clangLex
  clangTooling
)

=== src/llvm-project/clang-tools-extra/clangd/index/dex/dexp/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)

set(LLVM_LINK_COMPONENTS
  LineEditor
  Support
  )

add_clang_executable(dexp
  Dexp.cpp
  )

target_link_libraries(dexp
  PRIVATE
  clangBasic
  clangDaemon
  )

=== src/llvm-project/lldb/packages/Python/lldbsuite/test/macosx/find-dsym/deep-bundle/Makefile ===
SRCDIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))/

CC ?= clang

ifeq "$(ARCH)" ""
	ARCH = x86_64
endif

CFLAGS ?= -g -O0 -arch $(ARCH)

all: clean
	$(CC) $(CFLAGS) -install_name $(shell pwd)/MyFramework.framework/Versions/A/MyFramework -dynamiclib -o MyFramework $(SRCDIR)/myframework.c
	mkdir -p MyFramework.framework/Versions/A/Headers
	mkdir -p MyFramework.framework/Versions/A/Resources
	cp MyFramework MyFramework.framework/Versions/A
	cp $(SRCDIR)/MyFramework.h MyFramework.framework/Versions/A/Headers
	cp $(SRCDIR)/Info.plist MyFramework.framework/Versions/A/Resources
	( cd MyFramework.framework/Versions ; ln -s A Current )
	( cd MyFramework.framework/ ; ln -s Versions/Current/Headers . )
	( cd MyFramework.framework/ ; ln -s Versions/Current/MyFramework . )
	( cd MyFramework.framework/ ; ln -s Versions/Current/Resources . )
	mv MyFramework.dSYM MyFramework.framework.dSYM
	mkdir hide.app
	rm -f MyFramework
	tar cf - MyFramework.framework MyFramework.framework.dSYM | ( cd hide.app;tar xBpf -)
	$(CC) $(CFLAGS) -o deep-bundle $(SRCDIR)/main.c -F. -framework MyFramework


clean:
	rm -rf a.out a.out.dSYM deep-bundle deep-bundle.dSYM MyFramework.framework MyFramework.framework.dSYM MyFramework MyFramework.dSYM hide.app

=== debian/rules ===
--- 
+++ 
@@ -27,20 +27,16 @@
 include debian/architecture.mk
 export DEB_HOST_RUST_TYPE
 
+# Let rustbuild control whether LLVM is compiled with debug symbols, rather
+# than compiling with debug symbols unconditionally, which will fail on
+# 32-bit architectures
+CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
+CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
+
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
-
-# Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 9
-OLD_LLVM_VERSION = 8
-# Make it easier to test against a custom LLVM
-ifneq (,$(LLVM_DESTDIR))
-LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
-LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
-export LD_LIBRARY_PATH
-endif
 
 RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py
 RUSTBUILD_FLAGS = --config debian/config.toml -vvv --on-fail env
@@ -150,14 +146,12 @@
 		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
 		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
 		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
-		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
-		-DLLVM_VERSION="$(LLVM_VERSION)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
 		"$<" > "$@"
 	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
 	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 # Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
-ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
+ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
 	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
 endif
 
@@ -166,8 +160,6 @@
 		"$<" > "$@"
 
 debian/dh_auto_configure.stamp: debian/config.toml
-	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
-	! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude='*.patch' --exclude-dir='.debhelper' -R debian
 	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
 	test ! -e vendor/openssl
 	# fail the build if we didn't update d-ignore-error-detail-diff.patch
@@ -180,3 +172,11 @@
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
 	# work around https://github.com/rust-lang/rust/issues/59264
+	# TODO: remove this in 1.41 and later
+	if dpkg --compare-versions $(LOCAL_RUST_VERSION) '>=' 1.40.0; then \
+	 debian/ensure-patch -N debian/patches/u-compiletest-stage0-bump.patch; \
+	else \
+	 debian/ensure-patch -R debian/patches/u-compiletest-stage0-bump.patch; \
+	fi
+	# We patched some crates so have to rm the checksums
+	find vendor -name .cargo-checksum.json -execdir "$(CURDIR)/debian/prune-checksums" "{}" +
